
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef jloco_TCLSERV_CLIENT_MSG_LIB_H
#define jloco_TCLSERV_CLIENT_MSG_LIB_H

#include <server/jlocoType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int jlocoTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int jlocoTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int jlocoTclservClientInitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int jlocoTclservClientInitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int jlocoTclservClientInitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int jlocoTclservClientInitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int jlocoTclservClientSetWatchdogToleranceRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 int *(in_watchdogTolerance)
		);

int jlocoTclservClientSetWatchdogToleranceReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int jlocoTclservClientSetWatchdogToleranceRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 int *(in_watchdogTolerance) ,
				 
				 int *bilan);




int jlocoTclservClientGetWatchdogToleranceRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int jlocoTclservClientGetWatchdogToleranceReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       int *(out_watchdogTolerance),
			       int *bilan);

int jlocoTclservClientGetWatchdogToleranceRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 int *(out_watchdogTolerance),
				 int *bilan);




int jlocoTclservClientSetCmdParamRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 GENPOS_CART_CMD_PARAM *(in_cmdParam)
		);

int jlocoTclservClientSetCmdParamReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int jlocoTclservClientSetCmdParamRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 GENPOS_CART_CMD_PARAM *(in_cmdParam) ,
				 
				 int *bilan);




int jlocoTclservClientGetCmdParamRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int jlocoTclservClientGetCmdParamReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       GENPOS_CART_CMD_PARAM *(out_cmdParam),
			       int *bilan);

int jlocoTclservClientGetCmdParamRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 GENPOS_CART_CMD_PARAM *(out_cmdParam),
				 int *bilan);




int jlocoTclservClientSetOdoCorrectionRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 JLOCO_ODO_CORRECTION *(in_tmpOdoCorr)
		);

int jlocoTclservClientSetOdoCorrectionReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int jlocoTclservClientSetOdoCorrectionRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 JLOCO_ODO_CORRECTION *(in_tmpOdoCorr) ,
				 
				 int *bilan);




int jlocoTclservClientGetOdoCorrectionRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int jlocoTclservClientGetOdoCorrectionReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       JLOCO_ODO_CORRECTION *(out_tmpOdoCorr),
			       int *bilan);

int jlocoTclservClientGetOdoCorrectionRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 JLOCO_ODO_CORRECTION *(out_tmpOdoCorr),
				 int *bilan);




int jlocoTclservClientSetVarParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 JLOCO_VAR_PARAMS *(in_varParams)
		);

int jlocoTclservClientSetVarParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int jlocoTclservClientSetVarParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 JLOCO_VAR_PARAMS *(in_varParams) ,
				 
				 int *bilan);




int jlocoTclservClientSetPosRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 GENPOS_CART_CONFIG *(in_tmpPose)
		);

int jlocoTclservClientSetPosReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int jlocoTclservClientSetPosRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 GENPOS_CART_CONFIG *(in_tmpPose) ,
				 
				 int *bilan);




int jlocoTclservClientSetPosErrRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 GENPOS_CART_CONFIG_VAR *(in_tmpErr)
		);

int jlocoTclservClientSetPosErrReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int jlocoTclservClientSetPosErrRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 GENPOS_CART_CONFIG_VAR *(in_tmpErr) ,
				 
				 int *bilan);




int jlocoTclservClientSetGyroModeRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 int *(in_gyroMode)
		);

int jlocoTclservClientSetGyroModeReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int jlocoTclservClientSetGyroModeRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 int *(in_gyroMode) ,
				 
				 int *bilan);




int jlocoTclservClientGetGyroModeRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int jlocoTclservClientGetGyroModeReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       int *(out_gyroMode),
			       int *bilan);

int jlocoTclservClientGetGyroModeRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 int *(out_gyroMode),
				 int *bilan);




int jlocoTclservClientJoystickOnRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int jlocoTclservClientJoystickOnReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int jlocoTclservClientJoystickOnRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int jlocoTclservClientJoystickOnRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int jlocoTclservClientTrackStartRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 JLOCO_NAME *(in_posterName) 
		);

int jlocoTclservClientTrackStartReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int jlocoTclservClientTrackStartRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				JLOCO_NAME *(in_posterName) ,
				
				int *bilan);

int jlocoTclservClientTrackStartRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					JLOCO_NAME *(in_posterName) ,
					
					int *bilan);




int jlocoTclservClientTrackSpeedStartRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 JLOCO_NAME *(in_posterName) 
		);

int jlocoTclservClientTrackSpeedStartReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int jlocoTclservClientTrackSpeedStartRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				JLOCO_NAME *(in_posterName) ,
				
				int *bilan);

int jlocoTclservClientTrackSpeedStartRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					JLOCO_NAME *(in_posterName) ,
					
					int *bilan);




int jlocoTclservClientTrackEndRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int jlocoTclservClientTrackEndReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int jlocoTclservClientTrackEndRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int jlocoTclservClientSetPomRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 JLOCO_NAME *(in_posterName) 
		);

int jlocoTclservClientSetPomReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int jlocoTclservClientSetPomRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				JLOCO_NAME *(in_posterName) ,
				
				int *bilan);

int jlocoTclservClientSetPomRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					JLOCO_NAME *(in_posterName) ,
					
					int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* jlocoTCLSERV_CLIENT_MSG_LIB_H */

